#include "windows.h"
#include "msg_test.h"
#include "msg_test.rh"
#include "msg_box.h"

HINSTANCE hInst;

#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
{
  MSG msg;

  if (!hPrevInstance)
    if (!InitApplication(hInstance))
      return (FALSE);

  if (!InitInstance(hInstance, nCmdShow))
    return (FALSE);

  while (GetMessage(&msg, NULL, NULL, NULL)) {
   TranslateMessage(&msg);
   DispatchMessage(&msg);
  }
  return (msg.wParam);
}


BOOL InitApplication(HINSTANCE hInstance) 
{
  WNDCLASS  wc;

  wc.style = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc = MainWndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = NULL;
  wc.hCursor = LoadCursor(NULL, IDC_ARROW); 
  wc.hbrBackground = GetStockObject(WHITE_BRUSH); 
  wc.lpszMenuName =  "MainMenu";
  wc.lpszClassName = "MsgTestClass";

  return (RegisterClass(&wc));
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow) 
{
  HWND hWnd;

  hInst = hInstance;

  hWnd = CreateWindow(
      "MsgTestClass",
      "Timed MessageBox Sample Application", 
      WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT,
      CW_USEDEFAULT,
      CW_USEDEFAULT,
      CW_USEDEFAULT,
      NULL,
      NULL,
      hInstance,
      NULL
  );

  if (!hWnd)
    return (FALSE);

  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);
  return (TRUE);
}

LRESULT FAR PASCAL __export MainWndProc(HWND hWnd, UINT message,
                                        WPARAM wParam, LPARAM lParam)
{
  switch (message) {
    case WM_COMMAND: {
      switch(wParam) {

         case IDM_EXIT:
              DestroyWindow(hWnd);
              return 0;

         case IDM_REG:
              if (MessageBox(hWnd, "Regular Message Box",
                  "Title", MB_YESNO) == IDYES)
              {
                MessageBox(hWnd, "You answered Yes", "Information", MB_OK);
              }
              else
              {
                MessageBox(hWnd, "You answered No", "Information", MB_OK);
              }
              return 0;

         case IDM_TIMED:
              if (TimedMsgBox(hInst, hWnd, "Timed Message Box",
                              "Timeout in 10 secs",
                              MB_YESNO, IDYES, 10000) == IDYES)
              {
                MessageBox(hWnd, "You answered Yes (or timed out)",
                           "Information", MB_OK);
              }
              else
              {
                MessageBox(hWnd, "You answered No", "Information", MB_OK);
              }
              return 0;

         default:
              return (DefWindowProc(hWnd, message, wParam, lParam));
      } //switch wParam
    } // Case WM_COMMAND

    case WM_DESTROY:
         PostQuitMessage(0);
         return 0;

    default:
         return (DefWindowProc(hWnd, message, wParam, lParam));
  }
}
